﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
         Console.WriteLine(EncryptData("Test"));
         Console.WriteLine (DecryptData(EncryptData("Test")));
         Console.WriteLine(HashData("Test"));

         Console.ReadLine();
        }
        static string HashData(string plainText)
        {
            UnicodeEncoding UnicodeString = new UnicodeEncoding();
            
            //Convert the string into a byte array
            Byte[] PlainTextByte = UnicodeString.GetBytes(plainText);
            
            //Initalize the MD5 provider
            MD5CryptoServiceProvider MD5 = new MD5CryptoServiceProvider() ;
            
            //Computer the hash and store it as a byte array
            byte[] HashBytes = MD5.ComputeHash(PlainTextByte);
            
            //Convert the byte array and return as a string value
            return Convert.ToBase64String(HashBytes);
        }
        static string EncryptData(string plainText)
        {
            //Setting the Passphrase, salting value, and vector which will be used to encrypt the values.  These must be the same in your encryption and decryption functions.
            string passPhrase = "YourStrongPassword!";
            string SaltValue  = "Your$altValue";
            int passwordIterations = 2;
            string initVector = "d83jd72hs0wk3ldf";
            
            //Convert the text values into byte arrays
            byte[] initVectorBytes = Encoding.ASCII.GetBytes(initVector);
            byte[] saltValueBytes = Encoding.ASCII.GetBytes(SaltValue);
            byte[] plainTextBytes = Encoding.UTF8.GetBytes(plainText);
            
            //Create the password which will be used to encrypt the value based on the Passphrase, salt value, SHA1 hash, and Password Iterations specified.
            PasswordDeriveBytes password = new PasswordDeriveBytes(passPhrase, saltValueBytes, "SHA1", passwordIterations);
            
            //Create an array to hold the pseudo-random bytes for the encryption key.
            byte[] keyBytes = password.GetBytes(32);
            
            //Create an object to use for encryption.
            RijndaelManaged symmetricKey = new RijndaelManaged();
            
            //Set the encryption object for Ciopher Block Chaining.
            symmetricKey.Mode = CipherMode.CBC;
            
            //Generate the encryptor from the key bytes and the vector bytes.
            ICryptoTransform encryptor = symmetricKey.CreateEncryptor(keyBytes, initVectorBytes);
            
            //Create a memory stream object to hold the encrypted data.
            MemoryStream memoryStream = new MemoryStream();
            
            //Create cryptographic steam to do the encryption.
            CryptoStream cryptoStream = new CryptoStream(memoryStream, encryptor, CryptoStreamMode.Write);
            
            //Begin the encryption.
            cryptoStream.Write(plainTextBytes, 0, plainTextBytes.Length);
            
            //Finish the encryption.
            cryptoStream.FlushFinalBlock();
            
            //Convert the encrypted value into a new byte array.
            byte[] cipherTextBytes = memoryStream.ToArray();
            
            //Close the streams.
            memoryStream.Close();
            cryptoStream.Close();
            
            //Convert the encrypted value to a string value and return to the calling code.
            return Convert.ToBase64String(cipherTextBytes);
        }

        static string DecryptData(string EncryptedValue)
        {
            //Setting the Passphrase, salting value, and vector which will be used to encrypt the values.  These must be the same in your encryption and decryption functions.
            string passPhrase = "YourStrongPassword!";
            string SaltValue = "Your$altValue";
            int passwordIterations = 2;
            string initVector = "d83jd72hs0wk3ldf";
            
            //Convert the text values into byte arrays
            byte[] initVectorBytes = Encoding.ASCII.GetBytes(initVector);
            byte[] saltValueBytes = Encoding.ASCII.GetBytes(SaltValue);
            byte[] cipherTextBytes = Convert.FromBase64String(EncryptedValue);
            
            //Create the password which will be used to decrypt the value based on the Passphrase, salt value, SHA1 hash, and Password Iterations specified.
            PasswordDeriveBytes password = new PasswordDeriveBytes(passPhrase, saltValueBytes, "SHA1", passwordIterations);
            
            //Create an array to hold the pseudo-random bytes for the encryption key.
            byte[] keyBytes = password.GetBytes(32);
            
            //Create an object to use for encryption.
            RijndaelManaged symmetricKey = new RijndaelManaged();
            
            //Set the encryption object for Ciopher Block Chaining.
            symmetricKey.Mode = CipherMode.CBC;
            
            //Generate the decryptor from the key bytes and the vector bytes.
            ICryptoTransform decryptor = symmetricKey.CreateDecryptor(keyBytes, initVectorBytes);
            
            //Create a memory stream object to hold the decrypted data.
            MemoryStream memoryStream = new MemoryStream(cipherTextBytes);
            
            //Create cryptographic steam to do the decryption.
            CryptoStream cryptoStream = new CryptoStream(memoryStream, decryptor, CryptoStreamMode.Read);
            
            //Create a byte array based on the size of the memorystream object
            byte[] plainTextBytes = new byte[cipherTextBytes.Length];
            
            //Decrypt the data
            int decryptedByteCount = cryptoStream.Read(plainTextBytes, 0, plainTextBytes.Length);
            
            //close the streams
            memoryStream.Close();
            cryptoStream.Close();
            
            //Convert the decrypted value to a string value and return to the calling code
            return Encoding.UTF8.GetString(plainTextBytes, 0, decryptedByteCount);
        }
    }
}
